#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <string>
#ifdef DEBUG
#include <fstream>
std::ifstream fin("test.txt");
#define cin fin
#else
struct fake_ostream {} fout;
template<class T> fake_ostream& operator << (fake_ostream& out, const T& val)
{
	return out;
}
#define cerr fout
#endif

#define int int64_t

using namespace std;

template<class T> inline const T& mymin(const T& x, const T& y)
{
	return x ? (y ? min(x, y) : x) : y;
}

struct aut
{
	const int alph = 'z' - 'a' + 1;
	vector<vector<int> > go;
	vector<int> cost;
	aut() : go(1, vector<int>(alph, -1)), cost(1) {}
	void add(string s, int cst)
	{
		int v = 0;
		for (char c : s)
		{
			if (go[v][c - 'a'] == -1)
			{
				go[v][c - 'a'] = go.size();
				go.push_back(vector<int>(alph, -1));
				cost.push_back(0);
			}
			v = go[v][c - 'a'];
		}
		cost[v] = mymin(cost[v], cst);
	}
};

const size_t maxn = 500;

long long mc[maxn][maxn] = {};
long long dp[maxn] = {};

vector<int> ch[maxn];
int par[maxn];
char pc[maxn];

long long count_dp(long long v, long long p)
{
	long long ch_s = 0;
	for (int u : ch[v])
	{
		if (!dp[u])
			return 0;
		ch_s += dp[u];
	}
	if (!mc[v][p])
		return 0;
	long long ret = ch_s + mc[v][p];
	for (int u : ch[v])
	{
		long long k = count_dp(u, p);
		if (k)
			ret = mymin(ret, k + ch_s - dp[u]);
	}
	return ret;
}

int32_t main()
{
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++)
	{
		int p;
		char c;
		cin >> p >> c;
		--p;
		par[i] = p;
		pc[i] = c;
		ch[p].push_back(i);
	}
	par[0] = -1;
	pc[0] = '#';
	aut T;
	for (int i = 0; i < m; i++)
	{
		int w;
		string s;
		cin >> w >> s;
		reverse(s.begin(), s.end());
		T.add(s, w);
	}
	for (int i = n - 1; i > 0; --i)
	{
		int v = 0;
		char c = pc[i];
		vector<int> pars;
		for (int j = par[i]; j >= 0; j = par[j])
		{
			char oc = c;
			c = pc[j];
			pars.push_back(j);
			for (auto u : ch[i])
				mc[i][j] = mymin(mc[u][j], mc[i][j]);
			if (v < 0)
				continue;
			v = T.go[v][oc - 'a'];
			if (v < 0)
				continue;
			mc[i][j] = mymin(mc[i][j], T.cost[v]);
		}
		if (pars.empty())
			continue;
		reverse(pars.begin(), pars.end());
		for (int j = 1; j < (int)pars.size(); j++)
			mc[i][pars[j]] = mymin(mc[i][pars[j]], mc[i][pars[j - 1]]);
	}
	for (int i = n - 1; i > 0; --i)
		dp[i] = count_dp(i, par[i]);
	long long ans = 0;
	for (int u : ch[0])
		if (!dp[u])
		{
			cout << -1;
			return 0;
		}
		else
			ans += dp[u];
	cout << ans;
	return 0;
}