#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <string>
#ifdef DEBUG
#include <fstream>
std::ifstream fin("test.txt");
#define cin fin
#else
struct fake_ostream {} fout;
template<class T> fake_ostream& operator << (fake_ostream& out, const T& val)
{
	return out;
}
#define cerr fout
#endif

using namespace std;

inline long long mymin(long long x, long long y)
{
	return x ? (y ? min(x, y) : x) : y;
}

struct aut
{
	const int alph = 'z' - 'a' + 1;
	vector<vector<int> > go;
	vector<int> cost;
	aut() : go(1, vector<int>(alph, -1)), cost(1, 0) {}
	void add(string s, int cst)
	{
		int v = 0;
		for (char c : s)
		{
			if (go[v][c - 'a'] == -1)
			{
				go[v][c - 'a'] = go.size();
				go.push_back(vector<int>(alph, -1));
				cost.push_back(0);
			}
			v = go[v][c - 'a'];
		}
		cost[v] = mymin(cost[v], cst);
	}
} T;

const int maxn = 500;
int path_c[maxn][maxn] = {};
int par[maxn];
char pc[maxn];
vector<int> ch[maxn];

int count_pc(int v, int p, int aut_v)
{
	if (p)
		path_c[v][p] = path_c[v][par[p]];
	if (aut_v != -1)
		aut_v = T.go[aut_v][pc[v] - 'a'];
	if (aut_v != -1)
		path_c[v][p] = mymin(T.cost[aut_v], path_c[v][p]);
	for (int u : ch[v])
		path_c[v][p] = mymin(path_c[v][p], count_pc(u, p, aut_v));
	return path_c[v][p];
}

long long dp[maxn];

long long count_dp(int v, int p)
{
	if (!path_c[v][p])
		return 0;
	long long ch_s = 0;
	for (int u : ch[v])
		ch_s += dp[u];
	long long ret = ch_s + (long long)path_c[v][p];
	for (int u : ch[v])
	{
		long long k = count_dp(u, p);
		if (k)
			ret = mymin(ret, ch_s - dp[u] + k);
	}
	return ret;
}

int main()
{
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; i++)
	{
		cin >> par[i] >> pc[i];
		--par[i];
		ch[par[i]].push_back(i);
	}
	for (int i = 0; i < m; i++)
	{
		int w;
		cin >> w;
		string s;
		cin >> s;
		T.add(s, w);
	}
	for (int i = 0; i < n; i++)
		for (auto u : ch[i])
			count_pc(u, i, 0);
	for (int i = n - 1; i > 0; i--)
		if (!(dp[i] = count_dp(i, par[i])))
		{
			cout << -1;
			return 0;
		}
	long long ans = 0;
	for (int u : ch[0])
		ans += dp[u];
	cout << ans;
	return 0;
}