#include <iostream>
#include <vector>
#include <algorithm>
#ifdef DEBUG
#include <fstream>
std::ifstream fin("test.txt");
#define cin fin
#else
struct fake_ostream {} fout;
template <class T> fake_ostream& operator << (fake_ostream& out, const T& val)
{
	return out;
}
#define cerr fout
#endif

using namespace std;

struct dp_val
{
	vector<int> cols;
	vector<int> costs;
};

struct node
{
	node *L, *R;
	int col;
	node() : col(0), L(nullptr), R(nullptr) {}
	void col_seg(int l, int r, int tl, int tr, int tcol)
	{
		cerr << "col " << l << " " << r << " " << tl << " " << tr << " " << tcol << "\n";
		if (l >= tr || tl >= r)
			return;
		if (tl <= l && tr >= r)
		{
			col = tcol;
			cerr << "colored\n";
			return;
		}
		int m = (r + l) / 2;
		if (!L)
			L = new node();
		if (!R)
			R = new node();
		L->col_seg(l, m, tl, tr, tcol);
		R->col_seg(m, r, tl, tr, tcol);
	}
	dp_val dp(int db_l, int db_r) const
	{
		cerr << "dp " << db_l << " " << db_r << "\n";
		dp_val ret;
		if (col)
		{
			cerr << "term : " << col << "\n";
			ret.cols = { 0, col };
			ret.costs = { 1, 0 };
			cerr << db_l << " " << db_r << " res = [0, 1] [" << col << ", 0]\n";
			return ret;
		}
		int db_m = (db_l + db_r) / 2;
		auto l = L->dp(db_l, db_m);
		auto r = R->dp(db_m, db_r);
		ret.cols.resize(l.cols.size() + r.cols.size());
		int cit = 0;
		for (auto v : l.cols)
			ret.cols[cit++] = v;
		for (auto v : r.cols)
			ret.cols[cit++] = v;
		sort(ret.cols.begin(), ret.cols.end());
		ret.cols.resize(unique(ret.cols.begin(), ret.cols.end()) - ret.cols.begin());
		ret.costs.resize(ret.cols.size());
		int lit = 0, rit = 0;
		for (int i = 0; i < ret.cols.size(); i++)
		{
			if (lit < l.cols.size() && l.cols[lit] == ret.cols[i])
				ret.costs[i] += l.costs[lit++];
			else
				ret.costs[i] += l.costs[0];
			if (rit < r.cols.size() && r.cols[rit] == ret.cols[i])
				ret.costs[i] += r.costs[rit++];
			else
				ret.costs[i] += r.costs[0];
		}
		int mc = ret.costs[0];
		for (int i = 0; i < ret.costs.size(); i++)
			mc = min(mc, ret.costs[i]);
		for (int i = 0; i < ret.costs.size(); i++)
			ret.costs[i] = min(ret.costs[i], mc + 1);
		cerr << db_l << " " << db_r << " res = ";
		for (int i = 0; i < ret.cols.size(); i++)
			cerr << "[" << ret.cols[i] << " " << ret.costs[i] << "] ";
		cerr << "\n";
		return ret;
	}
};

int main()
{
	int k, n, m;
	cin >> k >> n >> m;
	node T;
	for (int i = 0, l = 0; i < n; i++)
	{
		int x, v;
		cin >> x >> v;
		T.col_seg(0, 1 << k, l, l + x, v);
		l += x;
	}
	cout << T.dp(0, 1 << k).costs[0];
	return 0;
}